# -*- ruby -*-

#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-11-17 08:31:37 +0900 (Mon, 17 Nov 2003) $
#   $LastChangedBy: sugi $
#

module VFS;  module SchemeHandler;  module FILE;
  module Common

    def initialize(uri)
      super
      @uri.scheme ||= "file"
      if @uri.scheme != "file"
	raise Error::InvalidURI,
	  %Q{invalid URI '#{uri}' was specicied}
      end
      if @uri.host
	raise Error::InvalidURI,
	  %Q{"file://*remote-host*/path" style is not supported.}
      end
    end

    private
    def local_path
      VFS.unescape(uri.opaque ? uri.opaque : uri.path)
    end
  end # Common

  module MethodGenerator
    include VFS::MethodGenerator
    private
    def relay_realpath_to_file_builtin(*symbols)
      gen_delegate_method([:FileBuiltIn,
			  "*arg, &block",
			  "local_path, *arg, &block"],
			  *symbols)
    end

    def relay_realpath_to_dir_builtin(*symbols)
      gen_delegate_method([:DirBuiltIn,
			  "*arg, &block",
			  "local_path, *arg, &block"],
			  *symbols)
    end
  end # MethodGenerator
end; end; end
